#!/usr/bin/perl --
use strict;
use CGI qw(-nosticky -no_xhtml :standard :html4);
# use CGI::Carp qw(fatalsToBrowser);
require './jcode.pl';
require './clapmod.pl';

# this program is a cgi to support the web clap.
# written by IMAI Toshiyuki at http://www.kototone.jp/
#
# version history
# 2005-10-29 : ver. 1, modifying messages and uploading files
# 2007-10-08 : ver. 2, added message filter
# 2008-01-27 : ver. 3, added web clap config edit mode

my $charset = 'shift_jis';

$CGI::POST_MAX = 1024 * &getParams('file_size');
my $q = new CGI;
$q->charset($charset);
my $myself = $q->url(-relative=>1);
my $backward = $q->p({-class=>'backward'},
                     $q->a({-href=>$myself},
                           'gbvy[W'));

# get cookie and check login status
my %cookievalue;
$cookievalue{password} = '';
my $cookiepath = $q->url(-path_info=>1);
my %cookiedata = $q->cookie('WEB_CLAP_MAINTENANCE_TOOLS');
unless($cookiedata{password}) {
    $cookievalue{password} = $q->param('password');
} else {
    if ($q->param('password')) {
        $cookievalue{password} = $q->param('password');
    } else {
        $cookievalue{password} = $cookiedata{password};
    }
}

my $cookie = $q->cookie(-name=>'WEB_CLAP_MAINTENANCE_TOOLS',
                        -value=>\%cookievalue,
                        -expires=>'+3h');

&print_headers($q, $cookie);

if ($cookievalue{password} eq '') {
    &print_login_page($q, 'pX[h͂ĂB');
    print $q->end_html;
    exit;
} elsif (&chkPassword($cookievalue{password}) == 0) {
    &print_login_page($q, 'pX[hႢ܂B');
    print $q->end_html;
    exit;
}

# printing pages
if ($q->cgi_error) {
    print $q->p($q->cgi_error);
}
my $mode = $q->param('mode');
if ($mode eq 'mes_edit') {
    &print_edit_message_form($q);
} elsif ($mode eq 'mes_edited') {
    &edit_message($q);
} elsif ($mode eq 'mes_preview') {
    &preview_message($q);
} elsif ($mode eq 'mes_up') {
    &upward_message($q);
} elsif ($mode eq 'mes_down') {
    &downward_message($q);
} elsif ($mode eq 'mes_view') {
    &switch_view_message($q);
} elsif ($mode eq 'mes_delete') {
    &print_delete_message_confirm($q);
} elsif ($mode eq 'mes_delete_yes') {
    &delete_message($q);
} elsif ($mode eq 'mes_add') {
    &print_add_message_form($q);
} elsif ($mode eq 'mes_post') {
    &add_message($q);
} elsif ($mode eq 'file_add') {
    &add_file($q);
} elsif ($mode eq 'file_delete') {
    &print_delete_file_confirm($q);
} elsif ($mode eq 'file_delete_yes') {
    &delete_file($q);
} elsif ($mode eq 'open_denial_setting') {
    &print_denial_setting_page($q);
} elsif ($mode eq 'dl_switch') {
    &switch_active_dl_item($q);
} elsif ($mode eq 'dl_edit') {
    &print_edit_dl_item_form($q);
} elsif ($mode eq 'dl_edited') {
    &edit_dl_item($q);
} elsif ($mode eq 'dl_delete') {
    &print_delete_dl_item_confirm($q);
} elsif ($mode eq 'dl_delete_yes') {
    &delete_dl_item($q);
} elsif ($mode eq 'dl_add') {
    &print_add_dl_item_form($q);
} elsif ($mode eq 'dl_post') {
    &add_dl_item($q);
} elsif ($mode eq 'open_config_setting') {
    &print_config_setting_page($q);
} elsif ($mode eq 'config_edited') {
    &edit_config($q);
} 

&print_basic_forms($q);
print $q->end_html;
exit;


#############
# functions #
#############

# functions of messages
sub print_edit_message_form() {
    my $q = shift;

    my @mes_items = &getMessages('All');
    my $line = $q->param('line');

    if ($line =~ /^\d+/ && $line <= $#mes_items) {
        (my $message, my $view) = split(/<>/, $mes_items[$line]);
        $message = &desanit($message);
        print $q->p('bZ[W̕ҏW܂B');
        print $q->start_div({-class=>'message_form'}),
        $q->start_form(-action=>$myself),
        $q->p($q->textarea(-name=>'posted_message',
                           -default=>$message,
                           -override=>1)),
        $q->p($q->checkbox(-name=>'mes_view',
                           -checked=>$view,
                           -label=>'\',
                           -override=>1)),
        $q->hidden(-name=>'mode',
                   -value=>'mes_edited',
                   -override=>1),
        $q->hidden(-name=>'line',
                   -value=>$line,
                   -override=>1),
        $q->p($q->submit('ύX')),
        $q->end_form,
        $q->end_div;

        print $backward;

        my @imagelist = &get_imagelist();
        my %paths = &getPaths();
        print $q->h2('t@Cꗗ'),
        $q->start_ul;
        foreach my $li (@imagelist) {
            if ($li ne '.' && $li ne '..') {
                print $q->li($paths{images_rel}.$li);
            }
        }
        print $q->end_ul;

        print $backward;
        print $q->end_html;
        exit;
    } else {
        print $q->p('^ꂽlsłB');
    }
}

sub edit_message() {
    my $q = shift;

    my $line = $q->param('line');

    my @mes_items;
    my %paths = &getPaths();
    open(my $mf, "+<$paths{messages}");
    eval flock($mf, 2);
    my @mes_items = <$mf>;

    if ($line =~ /^\d+/ && $line <= $#mes_items) {
        if ($q->param('posted_message') eq '') {
            print $q->p('bZ[W͕ύXĂ܂B');
        } else {
            my $temp_item = &sanit($q->param('posted_message'));
            $temp_item = &codeenc($temp_item, 'sjis');
            if ($q->param('mes_view') eq 'on') {
                $temp_item = $temp_item.'<>1<>'."\n";
            } else {
                $temp_item = $temp_item.'<>0<>'."\n";
            }
            $mes_items[$line] = $temp_item;

            seek($mf, 0, 0);
            foreach my $li (@mes_items) {
                print $mf $li;
            }
            my $fp = tell($mf);
            truncate($mf, $fp);
            close($mf);
            print $q->p('bZ[WύX܂B');
        }
    } else {
        print $q->p('^ꂽlsłB');
        close($mf);
    }
}

sub preview_message() {
    my $q = shift;

    my $line = $q->param('line');

    my @mes_items = &getMessages('All');
    if ($line =~ /\d+/ && $line <= $#mes_items) {
        (my $message, my $view) = split(/<>/, $mes_items[$line]);
        $message = &desanit($message);
        print $q->h2('bZ[Wvr[');
        print $q->div({-class=>'mes_exemple'}, $message);
        print $backward;
	print $q->end_html;
        exit;
    } else {
        print $q->p('^ꂽlsłB');
    }
}

sub upward_message() {
    my $q = shift;

    my $line = $q->param('line');

    my @mes_items;
    my %paths = &getPaths();
    open(my $mf, "+<$paths{messages}");
    eval flock($mf, 2);
    my @mes_items = <$mf>;

    if ($line =~ /^\d+/ && $line <= $#mes_items && $line != 0) {
        my $temp_item = $mes_items[$line];
        $mes_items[$line] = $mes_items[($line - 1)];
        $mes_items[($line - 1)] = $temp_item;

        seek($mf, 0, 0);
        foreach my $li (@mes_items) {
            print $mf $li;
        }
        my $fp = tell($mf);
        truncate($mf, $fp);
        close($mf);

        print $q->p('bZ[W̕тύX܂B');
    } else {
        print $q->p('^ꂽlsłB');
        close($mf);
    }
}

sub downward_message() {
    my $q = shift;

    my $line = $q->param('line');

    my @mes_items;
    my %paths = &getPaths();
    open(my $mf, "+<$paths{messages}");
    eval flock($mf, 2);
    my @mes_items = <$mf>;

    if ($line =~ /^\d+/ && $line < $#mes_items) {
        my $temp_item = $mes_items[$line];
        $mes_items[$line] = $mes_items[($line + 1)];
        $mes_items[($line + 1)] = $temp_item;

        seek($mf, 0, 0);
        foreach my $li (@mes_items) {
            print $mf $li;
        }
        my $fp = tell($mf);
        truncate($mf, $fp);
        close($mf);

        print $q->p('bZ[W̕тύX܂B');
    } else {
        print $q->p('^ꂽlsłB');
        close($mf);
    }
}

sub switch_view_message() {
    my $q = shift;

    my $line = $q->param('line');

    my @mes_items;
    my %paths = &getPaths();
    open(my $mf, "+<$paths{messages}");
    eval flock($mf, 2);
    my @mes_items = <$mf>;

    if ($line =~ /^\d+/ && $line <= $#mes_items) {
        (my $message, my $view) = split(/<>/, $mes_items[$line]);
        if ($view == 1) {
            $view = 0;
        } else {
            $view = 1;
        }
        $mes_items[$line] = $message.'<>'.$view.'<>'."\n";

        seek($mf, 0, 0);
        foreach my $li (@mes_items) {
            print $mf $li;
        }
        my $fp = tell($mf);
        truncate($mf, $fp);
        close($mf);

        print $q->p('bZ[W̕\/\؂ւ܂B');
    } else {
        print $q->p('^ꂽlsłB');
        close($mf);
    }
}

sub print_delete_message_confirm() {
    my $q = shift;

    my $line = $q->param('line');

    my @mes_items = &getMessages('All');
    if ($line =~ /^\d+/ && $line <= $#mes_items) {
        (my $message, my $view) = split(/<>/, $mes_items[$line]);
        $message = &desanit($message);
        print $q->p('ȉ̃bZ[W폜܂B낵łH');
        print $q->div({-class=>'mes_exemple'}, $message),
        $q->start_div({-class=>'delete_message_confirm'}),
        $q->start_form(-action=>$myself),
        $q->hidden(-name=>'mode',
                   -value=>'mes_delete_yes',
                   -override=>1),
        $q->hidden(-name=>'line',
                   -value=>$line,
                   -override=>1),
        $q->p($q->submit('폜')),
        $q->end_form,
        $q->end_div;

        print $backward;
        print $q->end_html;
        exit;
    } else {
        print $q->p('^ꂽlsłB');
    }
}

sub delete_message() {
    my $q = shift;

    my $line = $q->param('line');

    my @mes_items;
    my %paths = &getPaths();
    open(my $mf, "+<$paths{messages}");
    eval flock($mf, 2);
    my @mes_items = <$mf>;

    if ($line =~ /^\d+/ && $line <= $#mes_items) {
        if ($line < $#mes_items) {
            for (my $i = ($line + 1); $i <= $#mes_items; $i++) {
                $mes_items[$i - 1] = $mes_items[$i];
            }
        }
        pop(@mes_items);

        seek($mf, 0, 0);
        foreach my $li (@mes_items) {
            print $mf $li;
        }
        my $fp = tell($mf);
        truncate($mf, $fp);
        close($mf);

        print $q->p('bZ[W폜܂B');
    } else {
        print $q->p('^ꂽlsłB');
        close($mf);
    }
}

sub print_add_message_form() {
    my $q = shift;

    print $q->p('VKbZ[Wǉ܂B');
    print $q->start_form(-action=>$myself),
    $q->p($q->textarea(-name=>'posted_message',
                       -default=>'',
                       -override=>1)),
    $q->p($q->checkbox(-name=>'mes_view',
                       -checked=>1,
                       -label=>'\',
                       -override=>1)),
    $q->hidden(-name=>'mode',
               -value=>'mes_post',
               -override=>1),
    $q->p($q->submit('ǉ')),
    $q->end_form;

    print $backward;

    my @imagelist = &get_imagelist();
    my %paths = &getPaths();
    print $q->h2('t@Cꗗ');
    print $q->start_ul;
    foreach my $li (@imagelist) {
        if ($li ne '.' && $li ne '..') {
            print $q->li($paths{images_rel}.$li);
        }
    }
    print $q->end_ul;

    print $backward;
    print $q->end_html;
    exit;
}

sub add_message() {
    my $q = shift;

    if ($q->param('posted_message') eq '') {
        print $q->p('bZ[W͒ǉĂ܂B');
    } else {
        my @mes_items;
        my %paths = &getPaths();
        open(my $mf, "+<$paths{messages}");
        eval flock($mf, 2);
        my @mes_items = <$mf>;

        my $temp_item = &sanit($q->param('posted_message'));
        $temp_item = &codeenc($temp_item, 'sjis');
        if ($q->param('mes_view') eq 'on') {
            $temp_item = $temp_item.'<>1<>'."\n";
        } else {
            $temp_item = $temp_item.'<>0<>'."\n";
        }
        push(@mes_items, $temp_item);

        seek($mf, 0, 0);
        foreach my $li (@mes_items) {
            print $mf $li;
        }
        my $fp = tell($mf);
        truncate($mf, $fp);
        close($mf);

        print $q->p('bZ[Wǉ܂B');
    }
}

# functions of file upload
sub add_file() {
    my $q = shift;

    my $fh = $q->upload('uploaded_file');
    my $filename = $q->param('uploaded_file');

    if ($filename) {
        my $mimetype = $q->uploadInfo($fh)->{'Content-Type'};
        $filename =~ s/\\/\//g;
        $filename = substr($filename, rindex($filename, "/") + 1);
        $filename =~ s/\s/_/g;
        $filename = lc($filename);

        my $filename_error = '';
        my @imagelist = &get_imagelist();
        foreach my $li (@imagelist) {
            if ($li eq $filename) {
                $filename_error .= 't@Ci'.$filename.'j݂܂B';
            }
        }
        if ($filename !~ /^[\w-]+\.\w+$/) {
            $filename_error .= 't@C͉pɂĂB';
        }
        if (!(&getParams('upload_exe'))) {
            if ($filename =~ /.*\.(exe|bat|com|cgi|pl)$/) {
                $filename_error .= 's\t@C̓Abv[hł܂B';
            }
        }

        if ($filename_error eq '') {
            my %paths = &getPaths();
            my $filepath = $paths{images}.$filename;
            if (open(my $out, ">$filepath")) {
                eval flock($out, 2);
                binmode($out);
                while (read($fh, my $buffer, 1024)) {
                    print $out $buffer;
                }
                close($out);
                if ($CGI::OS ne 'unix') {
                    close($fh);
                }
                chmod(0666, $filepath);
                print $q->p('t@Ci'.$filename.'jǉ܂B');
            } else {
                close($out);
                print $q->p('t@C͕ۑĂ܂B');
            }
        } else {
            print $q->p($filename_error);
        }
    } else {
        print $q->p('t@C͕ۑĂ܂B');
    }
}

sub print_delete_file_confirm() {
    my $q = shift;

    print $q->p('ȉ̃t@C폜܂B낵łH'),
    $q->start_div({-class=>'delete_file_confirm'}),
    $q->p({-class=>'filename'}, $q->param('filename')),
    $q->start_form(-action=>$myself),
    $q->hidden(-name=>'mode',
               -value=>'file_delete_yes',
               -override=>1),
    $q->hidden(-name=>'filename',
               -value=>$q->param('filename'),
               -override=>1),
    $q->p($q->submit('폜')),
    $q->end_form,
    $q->end_div;

    print $backward;
    print $q->end_html;
    exit;
}

sub delete_file() {
    my $q = shift;

    my $filename = $q->param('filename');
    my %paths = &getPaths();
    unlink($paths{images}.$filename);
    print $q->p('t@Ci'.$filename.'j폜܂B');
}

# functions of denial list
sub print_add_dl_item_form() {
    my $q = shift;

    my %target_strings = ('m' => 'bZ[W',
                          'i' => 'IPAhX',
                          'h' => '[gzXg');

    print $q->p('ېݒǉ܂B'),
    $q->start_form(-action=>$myself),
    $q->p($q->textarea(-name=>'posted_disword',
                       -default=>'',
                       -override=>1)),
    $q->p($q->popup_menu(-name=>'dl_target',
                         -values=>\%target_strings,
                         -default=>'m',
                         -override=>1)),
    $q->p($q->checkbox(-name=>'dl_active',
                       -checked=>1,
                       -label=>'L',
                       -override=>1)),
    $q->hidden(-name=>'mode',
               -value=>'dl_post',
               -override=>1),
    $q->p($q->submit('ǉ')),
    $q->end_form;

    print $q->p({-class=>'backward'},
                $q->a({-href=>$myself.'?mode=open_denial_setting'},
                      'ېݒꗗɖ߂'));
    print $backward;
    print $q->end_html;
    exit;
}

sub add_dl_item() {
    my $q = shift;

    if ($q->param('posted_disword') eq '') {
        print $q->p('bZ[W͕ύXĂ܂B');
    } else {
        my @denial_items;
        my %paths = &getPaths();
        open(my $dlf, "+<$paths{denial_list}");
        eval flock($dlf, 2);
        my @denial_items = <$dlf>;
        
        my $temp_item = &sanit($q->param('posted_disword'));
        $temp_item = &codeenc($temp_item, 'sjis');
        $temp_item = $temp_item.'<>'.$q->param('dl_target');
        if ($q->param('dl_active') eq 'on') {
            $temp_item = $temp_item.'<>1<>'."\n";
        } else {
            $temp_item = $temp_item.'<>0<>'."\n";
        }
        push(@denial_items, $temp_item);

        seek($dlf, 0, 0);
        foreach my $li (@denial_items) {
            print $dlf $li;
        }
        my $fp = tell($dlf);
        truncate($dlf, $fp);
        close($dlf);

        print $q->p('bZ[Wǉ܂B');
    }
    &print_denial_setting_page($q);
    exit;
}

sub print_delete_dl_item_confirm() {
    my $q = shift;

    my $line = $q->param('line');

    my @denial_items;
    my %paths = &getPaths();
    open(my $dlf, "<$paths{denial_list}");
    eval flock($dlf, 2);
    my @denial_items = <$dlf>;
    close($dlf);

    my %target_strings = ('m' => 'bZ[W',
                          'i' => 'IPAhX',
                          'h' => '[gzXg');

    if ($line =~ /^\d+/ && $line <= $#denial_items) {
        (my $disword, my $target, my $active) = split(/<>/, $denial_items[$line]);
        $disword = &desanit($disword);
        print $q->p('ȉ̐ݒ폜܂B낵łH'),
        $q->dl({-class=>'dl_exemple'},
               $q->dt('ە'),
               $q->dd($disword),
               $q->dt('Ώ'),
               $q->dd($target_strings{$target}));
        print $q->start_div({-class=>'delete_dl_item_confirm'}),
        $q->start_form(-action=>$myself),
        $q->hidden(-name=>'line',
                   -value=>$line,
                   -override=>1),
        $q->hidden(-name=>'mode',
                   -value=>'dl_delete_yes',
                   -override=>1),
        $q->p($q->submit('폜')),
        $q->end_form,
        $q->end_div;

        print $q->p({-class=>'backward'},
                    $q->a({-href=>$myself.'?mode=open_denial_setting'},
                          'ېݒꗗɖ߂'));
        print $backward;
        print end_html;
        exit;
    } else {
        print $q->p('^ꂽlsłB');
    }
    &print_denial_setting_page($q);
    exit;
}

sub delete_dl_item() {
    my $q = shift;

    my $line = $q->param('line');

    my @denial_items;
    my %paths = &getPaths();
    open(my $dlf, "+<$paths{denial_list}");
    eval flock($dlf, 2);
    my @denial_items = <$dlf>;

    if ($line =~ /^\d+/ && $line <= $#denial_items) {
        if ($line < $#denial_items) {
            for (my $i = ($line + 1); $i <= $#denial_items; $i++) {
                $denial_items[$i - 1] = $denial_items[$i];
            }
        }
        pop(@denial_items);

        seek($dlf, 0, 0);
        foreach my $li (@denial_items) {
            print $dlf $li;
        }
        my $fp = tell($dlf);
        truncate($dlf, $fp);
        close($dlf);

        print $q->p('ݒ肪폜܂B');
    } else {
	print $q->p('^ꂽlsłB');
        close($dlf);
    }
    &print_denial_setting_page($q);
    exit;
}

sub print_edit_dl_item_form() {
    my $q = shift;

    my $line = $q->param('line');

    my @denial_items;
    my %paths = &getPaths();
    open(my $dlf, "<$paths{denial_list}");
    eval flock($dlf, 2);
    my @denial_items = <$dlf>;
    close $dlf;

    my %target_strings = ('m' => 'bZ[W',
                         'i' => 'IPAhX',
                         'h' => '[gzXg');

    if ($line =~ /^\d+/ && $line <= $#denial_items) {
        (my $disword, my $target, my $active) = split(/<>/, $denial_items[$line]);
        $disword = &desanit($disword);

        print $q->p('ېݒ̕ҏW܂'),
        $q->start_form(-action=>$myself),
        $q->p($q->textarea(-name=>'posted_disword',
                           -default=>$disword,
                           -override=>1)),
        $q->p($q->popup_menu(-name=>'dl_target',
                             -values=>\%target_strings,
                             -default=>$target,
                             -override=>1)),
        $q->p($q->checkbox(-name=>'dl_active',
                           -checked=>$active,
                           -label=>'L',
                           -override=>1)),
        $q->hidden(-name=>'line',
                   -value=>$line,
                   -override=>1),
        $q->hidden(-name=>'mode',
                   -value=>'dl_edited',
                   -override=>1),
        $q->p($q->submit('ύX')),
        $q->end_form;

        print $q->p({-class=>'backward'},
                    $q->a({-href=>$myself.'?mode=open_denial_setting'},
                          'ېݒꗗɖ߂'));
        print $backward;
        print end_html;
        exit;
    } else {
        print $q->p('^ꂽlsłB');
    }
    &print_denial_setting_page($q);
    exit;
}

sub edit_dl_item() {
    my $q = shift;

    my $line = $q->param('line');

    my @denial_items;
    my %paths = &getPaths();
    open(my $dlf, "+<$paths{denial_list}");
    eval flock($dlf, 2);
    my @denial_items = <$dlf>;

    if ($line =~ /^\d+/ && $line <= $#denial_items) {
        if ($q->param('posted_disword') eq '') {
            print $q->p('ېݒ͕ύXĂ܂B');
            close($dlf);
        } else {
            my $temp_item = &sanit($q->param('posted_disword'));
            $temp_item = &codeenc($temp_item, 'sjis');
            $temp_item = $temp_item.'<>'.$q->param('dl_target');
            if ($q->param('dl_active') eq 'on') {
                $temp_item = $temp_item.'<>1<>'."\n";
            } else {
                $temp_item = $temp_item.'<>0<>'."\n";
            }
            $denial_items[$line] = $temp_item;

            seek($dlf, 0, 0);
            foreach my $li (@denial_items) {
                print $dlf $li;
            }
            my $fp = tell($dlf);
            truncate($dlf, $fp);
            close($dlf);
            print $q->p('ېݒ肪ύX܂B');
        }
    } else {
        $q->p('^ꂽlsłB');
        close($dlf);
    }
    &print_denial_setting_page($q);
    exit;
}

sub switch_active_dl_item() {
    my $q = shift;

    my $line = $q->param('line');

    my @denial_items;
    my %paths = &getPaths();
    open(my $dlf, "+<$paths{denial_list}");
    eval flock($dlf, 2);
    my @denial_items = <$dlf>;

    if ($line =~ /^\d+/ && $line <= $#denial_items) {
        (my $disword, my $target, my $active) = split(/<>/, $denial_items[$line]);
        if ($active == 1) {
            $active = 0;
        } else {
            $active = 1;
        }
        $denial_items[$line] = $disword.'<>'.$target.'<>'.$active.'<>'."\n";

        seek($dlf, 0, 0);
        foreach my $li (@denial_items) {
            print $dlf $li;
        }
        my $fp = tell($dlf);
        truncate($dlf, $fp);
        close($dlf);

        print $q->p('ېݒ̗L/؂ւ܂B');
    } else {
        print $q->p('^ꂽlsłB');
        close($dlf);
    }
    &print_denial_setting_page($q);
    exit;
}


sub print_denial_setting_page() {
    my $q = shift;

    #############################
    # print denial setting page #
    #############################
    print $q->h2('ېݒꗗ');
    print $q->start_div(-class=>'dl_part');
    print $q->start_table,
    $q->caption('ېݒꗗ'),
    '<thead>',
    $q->Tr($q->th('ە'),
           $q->th('Ώ'),
           $q->th('ҏW'),
           $q->th('L/'),
           $q->th('폜')),
    '</thead><tbody>';

    my @denial_items;
    my %paths = &getPaths();
    open(my $dlf, "<$paths{denial_list}");
    eval flock($dlf, 2);
    my @denial_items = <$dlf>;
    close $dlf;

    my %target_strings = ('m' => 'bZ[W',
                          'i' => 'IPAhX',
                          'h' => '[gzXg');
    
    my $i = 0;
    foreach my $li (@denial_items) {
        (my $disword, my $target, my $active) = split(/<>/, $li);
        $disword = &desanit($disword);
        if (length($disword) > 100) {
            $disword = substr($disword, 0, 100).'...';
        }
        $disword = &sanit($disword);
        if ($active) {
            print $q->start_Tr;
        } else {
            print $q->start_Tr({-class=>'invisible'})
        }
        print $q->td({-class=>'main_item'}, $disword),
        $q->td($target_strings{$target});
        print $q->td($q->a({-href=>$myself.'?mode=dl_edit&line='.$i}, 'ҏW'));

        if ($active == 1) {
            print $q->start_td,
            $q->a({-href=>$myself.'?mode=dl_switch&line='.$i}, ''),
            $q->end_td;
        } else {
            print $q->start_td,
            $q->a({-href=>$myself.'?mode=dl_switch&line='.$i}, 'L'),
            $q->end_td;
        }

        print $q->start_td,
        $q->a({-href=>$myself.'?mode=dl_delete&line='.$i}, '폜'),
        $q->end_td,
        $q->end_Tr;
        $i++;
    }
    
    print '</tbody>',
    $q->end_table();

    print $q->start_form(-action=>$myself),
    $q->hidden(-name=>'mode',
               -value=>'dl_add',
               -override=>1),
    $q->p($q->submit('VKǉ')),
    $q->end_form;
    print $q->end_div;

    print $backward;
    print $q->end_html;
    exit;
}

# functions of config setting
sub print_config_setting_page() {
    my $q = shift;
    my %config = &getConfig();

    print $q->h2('webݒ');
    print $q->p('eݒύX܂');

    print $q->start_div({-class=>'config_table'}),
    $q->start_form(-action=>$myself),
    $q->hidden(-name=>'mode',
               -value=>'config_edited',
               -override=>1);

    print $q->start_table,
    $q->caption('webݒꗗ'),
    '<thead>',
    $q->Tr($q->th('ݒ荀'),
           $q->th('ݒl')),
    '</thead><tbody>';

    print $q->Tr($q->th('ꌾbZ[Wő啶'),
		 $q->td($q->textfield(-name=>'message_max_length',
				      -default=>$config{message_max_length},
				      -override=>1,
				      -size=>5)));
    print $q->Tr($q->th('Aő'),
		 $q->td($q->textfield(-name=>'clap_max_number',
				      -default=>$config{clap_max_number},
				      -override=>1,
				      -size=>5)));
    print $q->Tr($q->th('烁bZ[W_\'),
		 $q->td($q->checkbox(-name=>'random_switch',
				     -checked=>$config{random_switch},
				     -value=>'on',
				     -label=>'_',
				     -override=>1)));
    print $q->Tr($q->th('O̕ۑ'),
		 $q->td($q->textfield(-name=>'log_storage_life',
				      -default=>$config{log_storage_life},
				      -override=>1,
				      -size=>5)));

    print '</tbody>',
    $q->end_table();

    print $q->p($q->submit('ύX'),
		$q->reset()),
    $q->end_form(),
    $q->end_div();
    print $backward;
    print $q->end_html;
    exit;
}

sub edit_config() {
    my $q = shift;
    my $edit_switch = 0;

    my %paths = &getPaths();
    open(my $cf, "+<$paths{config_file}");
    eval flock($cf, 2);
    my @conflines = <$cf>;

    my @config = split(/<>/, $conflines[0]);
    if ($q->param('message_max_length') =~ /^\d+$/) {
	$config[0] = $q->param('message_max_length');
    } else {
	print $q->p('ꌾbZ[Wő啶͐lłȂ΂܂B');
    }

    if ($q->param('clap_max_number') =~ /^\d+$/) {
	$config[1] = $q->param('clap_max_number');
    } else {
	print $q->p('Aő񐔂͐lłȂ΂܂B');
    }

    if ($q->param('random_switch') eq 'on') {
	$config[2] = 1;
    } else {
	$config[2] = 0;
    }

    if ($q->param('log_storage_life') =~ /^\d+$/) {
	$config[3] = $q->param('log_storage_life');
    } else {
	print $q->p('O̕ۑԂ͐lłȂ΂܂B');
    }

    seek($cf, 0, 0);
    print $cf $config[0].'<>'.$config[1].'<>'.$config[2].'<>'.$config[3].'<>';

    my $fp = tell($cf);
    truncate($cf, $fp);
    close($cf);

    print $q->p('webݒύX܂B');

    &print_config_setting_page($q);
    exit;
}

sub print_basic_forms() {
    my $q = shift;

    ######################
    # print message list #
    ######################
    my @mes_items = &getMessages('All');
    print $q->h2('bZ[W'),
    $q->start_div({-class=>'mes_part'}),
    $q->start_table,
    $q->caption('bZ[Wꗗ'),
    '<thead>',
    $q->start_Tr,
    $q->th('bZ[W'),
    $q->th('vr['),
    $q->th('㏸/~'),
    $q->th('\/\'),
    $q->th('폜'),
    $q->end_Tr,
    '</thead><tbody>';

    my $i = 0;
    foreach my $li (@mes_items) {
        (my $message, my $view) = split(/<>/, $li);
        $message = &desanit($message);
        if (length($message) > 100) {
            $message = substr($message, 0, 100).'...';
        }
        $message = &sanit($message);
        if ($view) {
            print $q->start_Tr;
        } else {
            print $q->start_Tr({-class=>'invisible'});
        }
        print $q->td({-class=>'main_item'},
                     $q->a({-href=>$myself.'?mode=mes_edit&line='.$i},
                           $message)),
        $q->td($q->a({-href=>$myself.'?mode=mes_preview&line='.$i},
                     'vr['));
        print $q->start_td;
        if ($i == 0) {
            print '㏸','/';
        } else {
            print $q->a({-href=>$myself.'?mode=mes_up&line='.$i},
                        '㏸'),'/';
        }
        if ($i == $#mes_items) {
            print '~';
        } else {
            print $q->a({-href=>$myself.'?mode=mes_down&line='.$i},
                        '~');
        }
        print $q->end_td;

        my $text_view_switch = '\';
        if ($view == 1) {
            $text_view_switch = '\';
        }
        print $q->td($q->a({-href=>$myself.'?mode=mes_view&line='.$i},
                           $text_view_switch));
        print $q->td($q->a({-href=>$myself.'?mode=mes_delete&line='.$i},
                           '폜'));
        print $q->end_Tr;
        $i++;
    }
    print '</tbody>',
    $q->end_table;
    print $q->start_form(-action=>$myself),
    $q->hidden(-name=>'mode',
               -value=>'mes_add',
               -override=>1),
    $q->p($q->submit('VKǉ')),
    $q->end_form,
    $q->end_div;
    print $backward;

    #############################
    # print file uploading form #
    #############################
    print $q->h2('t@C'),
    $q->start_div({-class=>'file_part'}),
    $q->start_table,
    $q->caption('t@Cꗗ'),
    '<thead>',
    $q->Tr($q->th('t@C'),
           $q->th('폜')),
    '</thead><tbody>';
    my @imagelist = &get_imagelist();
    foreach my $li (@imagelist) {
        if ($li ne '.' && $li ne '..') {
            print $q->Tr($q->td({-class=>'main_item'}, $li),
                         $q->td($q->a({-href=>$myself.'?mode=file_delete&filename='.$li},
                                      '폜')));
        }
    }
    print '</tbody>',
    $q->end_table;

    print $q->start_multipart_form(-action=>$myself),
    $q->hidden(-name=>'mode',
               -value=>'file_add',
               -override=>1),
    $q->p($q->filefield(-name=>'uploaded_file',
                        -value=>'',
                        -override=>1),' ',
          $q->submit('t@Cǉ')),
    $q->end_multipart_form,
    $q->end_div;
    print $backward;

    ########################
    # print config setting #
    ########################
    print $q->h2('webݒ'),
    $q->start_div(-class=>'config_part'),
    $q->start_form(-action=>$myself),
    $q->hidden(-name=>'mode',
	       -value=>'open_config_setting',
	       -override=>1),
    $q->p($q->submit('webݒ')),
    $q->end_form,
    $q->end_div;
    print $backward;


    ########################
    # print denial setting #
    ########################
    print $q->h2('ېݒ'),
    $q->start_div(-class=>'dl_part'),
    $q->start_form(-action=>$myself),
    $q->hidden(-name=>'mode',
               -value=>'open_denial_setting',
               -override=>1),
    $q->p($q->submit('ېݒ')),
    $q->end_form,
    $q->end_div;
    print $backward;
}

sub print_login_page() {
    my $q = shift;
    my $message = shift;
    if ($message) {
        print $q->p($message);
    }
    print $q->start_form,
    $q->p($q->password_field(-name=>'password').' ',
	  $q->submit(-name=>'submit', -value=>'M')),
    $q->end_form,
}

sub get_imagelist() {
    my %paths = &getPaths;
    my $target_dir = $paths{images};
    opendir(my $imgdir, $target_dir);
    my @imagelist = readdir($imgdir);
    closedir($imgdir);
    return @imagelist;
}

sub print_headers() {
    my $q = shift;
    my $cookie = shift;

    my $title = &getParams('page_title');
    my $css_path = &getParams('css_path');

    print $q->header(-type=>'text/html', -cookie=>$cookie),
    $q->start_html(-lang=>'ja',
                   -title=>$title,
                   -head=>[meta({-http_equiv=>'Content-Stype-Type',
                                 -content=>'text/css'}),
                           Link({-rel=>'stylesheet',
                                 -href=>$css_path,
                                 -type=>'text/css'})]),
    $q->h1($title);
}
